import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { initDomain } from 'resolve-core';
import { Phases, symbol } from './constants';
import transformEvents from './transform-events';

var makeDummyEventStoreAdapter = function makeDummyEventStoreAdapter(_ref) {
  var events = _ref.events,
      aggregateId = _ref.aggregateId;
  var savedEvents = [];
  return {
    getNextCursor: function () {
      var _getNextCursor = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", Promise.resolve(null));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function getNextCursor() {
        return _getNextCursor.apply(this, arguments);
      }

      return getNextCursor;
    }(),
    saveSnapshot: function () {
      var _saveSnapshot = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", Promise.resolve());

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function saveSnapshot() {
        return _saveSnapshot.apply(this, arguments);
      }

      return saveSnapshot;
    }(),
    loadSnapshot: function () {
      var _loadSnapshot = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", Promise.resolve(null));

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function loadSnapshot() {
        return _loadSnapshot.apply(this, arguments);
      }

      return loadSnapshot;
    }(),
    saveEvent: function () {
      var _saveEvent = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(event) {
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                savedEvents.push(event);

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function saveEvent(_x) {
        return _saveEvent.apply(this, arguments);
      }

      return saveEvent;
    }(),
    loadEvents: function () {
      var _loadEvents = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
        return _regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt("return", Promise.resolve({
                  events: transformEvents(events, 'aggregate', {
                    aggregateId: aggregateId
                  })
                }));

              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function loadEvents() {
        return _loadEvents.apply(this, arguments);
      }

      return loadEvents;
    }()
  };
};

export var executeCommand = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6(context) {
    var createCommand, state, domain, assertion, resolve, reject, executor, result, event;
    return _regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            createCommand = context.createCommand, state = context.promise[symbol];

            if (!(state.phase < Phases.COMMAND)) {
              _context6.next = 3;
              break;
            }

            throw new TypeError("unexpected phase");

          case 3:
            domain = initDomain({
              viewModels: [],
              readModels: [],
              aggregates: [{
                name: state.aggregate.name,
                projection: state.aggregate.projection,
                commands: state.aggregate.commands,
                encryption: state.aggregate.encryption || null,
                deserializeState: JSON.parse,
                serializeState: JSON.stringify,
                invariantHash: 'invariant-hash'
              }],
              sagas: []
            });
            assertion = state.assertion, resolve = state.resolve, reject = state.reject;
            executor = null;
            _context6.prev = 6;
            executor = createCommand({
              performanceTracer: null,
              aggregatesInterop: domain.aggregateDomain.acquireAggregatesInterop({
                eventstore: makeDummyEventStoreAdapter(state),
                secretsManager: state.secretsManager,
                monitoring: {},
                hooks: {}
              })
            });
            _context6.next = 10;
            return executor({
              aggregateId: state.aggregateId,
              aggregateName: state.aggregate.name,
              type: state.command.name,
              payload: state.command.payload || {},
              jwt: state.jwt
            });

          case 10:
            result = _context6.sent;
            event = {
              type: result.type
            };

            if (Object.prototype.hasOwnProperty.call(result, 'payload')) {
              event['payload'] = result['payload'];
            }

            return _context6.abrupt("return", assertion(resolve, reject, event, null));

          case 16:
            _context6.prev = 16;
            _context6.t0 = _context6["catch"](6);
            return _context6.abrupt("return", assertion(resolve, reject, null, _context6.t0));

          case 19:
            _context6.prev = 19;

            if (!executor) {
              _context6.next = 23;
              break;
            }

            _context6.next = 23;
            return executor.dispose();

          case 23:
            return _context6.finish(19);

          case 24:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, null, [[6, 16, 19, 24]]);
  }));

  return function executeCommand(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
//# sourceMappingURL=execute-command.js.map