"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.executeReadModel = void 0;

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _constants = require("./constants");

var _resolveCore = require("resolve-core");

var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(_ref) {
    var promise, createQuery, transformEvents, detectConnectorFeatures, connectorModes, errors, queryExecutor, result, performAcknowledge, acknowledgePromise, provideLedger, secretsManager, liveErrors, wrapProjectionLiveErrors, domain, eventstoreAdapter, isInlineLedger, status, liveErrorIndex, error, _yield$acknowledgePro, projectionError, _liveErrorIndex, _error, _yield$queryExecutor$, summaryError;

    return _regenerator["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents, detectConnectorFeatures = _ref.detectConnectorFeatures, connectorModes = _ref.connectorModes;

            if (!(promise[_constants.symbol].phase < _constants.Phases.RESOLVER)) {
              _context6.next = 3;
              break;
            }

            throw new TypeError(promise[_constants.symbol].phase);

          case 3:
            errors = [];
            queryExecutor = null;
            result = null;
            _context6.prev = 6;
            performAcknowledge = null;
            acknowledgePromise = new Promise(function (resolve) {
              performAcknowledge = /*#__PURE__*/function () {
                var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(result) {
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return resolve(result);

                        case 2:
                          return _context.abrupt("return", _context.sent);

                        case 3:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function performAcknowledge(_x2) {
                  return _ref3.apply(this, arguments);
                };
              }();
            });

            provideLedger = /*#__PURE__*/function () {
              var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(ledger) {
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        return _context2.abrupt("return", void 0);

                      case 1:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2);
              }));

              return function provideLedger(_x3) {
                return _ref4.apply(this, arguments);
              };
            }();

            secretsManager = promise[_constants.symbol].secretsManager;
            liveErrors = [];

            wrapProjectionLiveErrors = function wrapProjectionLiveErrors(projection) {
              return Object.keys(projection).reduce(function (acc, key) {
                var _extends2;

                return (0, _extends3["default"])({}, acc, (_extends2 = {}, _extends2[key] = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
                  var _args3 = arguments;
                  return _regenerator["default"].wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          _context3.prev = 0;
                          _context3.next = 3;
                          return projection[key].apply(projection, _args3);

                        case 3:
                          return _context3.abrupt("return", _context3.sent);

                        case 6:
                          _context3.prev = 6;
                          _context3.t0 = _context3["catch"](0);
                          liveErrors.push(_context3.t0);
                          throw _context3.t0;

                        case 10:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3, null, [[0, 6]]);
                })), _extends2));
              }, {});
            };

            domain = (0, _resolveCore.initDomain)({
              viewModels: [],
              readModels: [{
                name: promise[_constants.symbol].name,
                projection: wrapProjectionLiveErrors(promise[_constants.symbol].projection),
                resolvers: promise[_constants.symbol].resolvers,
                connectorName: 'ADAPTER_NAME',
                encryption: promise[_constants.symbol].encryption
              }],
              aggregates: [],
              sagas: []
            });
            eventstoreAdapter = {
              getSecretsManager: function getSecretsManager() {
                return promise[_constants.symbol].secretsManager;
              },
              loadEvents: function () {
                var _loadEvents = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
                  return _regenerator["default"].wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          _context4.t0 = transformEvents(promise[_constants.symbol].events);
                          return _context4.abrupt("return", {
                            events: _context4.t0,

                            get cursor() {
                              throw new Error('Cursor should not be accessed from resolve-testing-tools');
                            }

                          });

                        case 2:
                        case "end":
                          return _context4.stop();
                      }
                    }
                  }, _callee4);
                }));

                function loadEvents() {
                  return _loadEvents.apply(this, arguments);
                }

                return loadEvents;
              }(),
              getNextCursor: function getNextCursor() {
                return 'SHIFT_CURSOR';
              }
            };
            queryExecutor = createQuery({
              readModelConnectors: {
                ADAPTER_NAME: promise[_constants.symbol].adapter
              },
              getVacantTimeInMillis: function getVacantTimeInMillis() {
                return 0x7fffffff;
              },
              invokeEventBusAsync: function () {
                var _invokeEventBusAsync = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
                  return _regenerator["default"].wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          return _context5.abrupt("return", void 0);

                        case 1:
                        case "end":
                          return _context5.stop();
                      }
                    }
                  }, _callee5);
                }));

                function invokeEventBusAsync() {
                  return _invokeEventBusAsync.apply(this, arguments);
                }

                return invokeEventBusAsync;
              }(),
              eventstoreAdapter: eventstoreAdapter,
              performAcknowledge: performAcknowledge,
              readModelsInterop: domain.readModelDomain.acquireReadModelsInterop({
                secretsManager: secretsManager,
                monitoring: {}
              }),
              viewModelsInterop: {},
              performanceTracer: null,
              provideLedger: provideLedger
            });
            _context6.next = 18;
            return detectConnectorFeatures(promise[_constants.symbol].adapter);

          case 18:
            _context6.t0 = _context6.sent;
            _context6.t1 = connectorModes.INLINE_LEDGER_CONNECTOR;
            isInlineLedger = _context6.t0 === _context6.t1;
            _context6.prev = 21;

            if (!isInlineLedger) {
              _context6.next = 45;
              break;
            }

            _context6.next = 25;
            return queryExecutor.subscribe({
              modelName: promise[_constants.symbol].name,
              subscriptionOptions: {
                eventTypes: null,
                aggregateIds: null
              }
            });

          case 25:
            _context6.next = 27;
            return queryExecutor.build({
              modelName: promise[_constants.symbol].name
            });

          case 27:
            _context6.next = 29;
            return queryExecutor.build({
              modelName: promise[_constants.symbol].name
            });

          case 29:
            _context6.next = 31;
            return queryExecutor.status({
              modelName: promise[_constants.symbol].name
            });

          case 31:
            status = _context6.sent;

            if (!(status.status === 'error')) {
              _context6.next = 43;
              break;
            }

            if (Array.isArray(status.errors)) {
              _context6.next = 35;
              break;
            }

            throw new Error('Unknown error');

          case 35:
            liveErrorIndex = status.errors.length === 1 ? liveErrors.findIndex(function (err) {
              return err.message === status.errors[0].message;
            }) : -1;

            if (!(liveErrorIndex < 0)) {
              _context6.next = 42;
              break;
            }

            error = new Error(status.errors.map(function (err) {
              return err.message;
            }).join('\n'));
            error.stack = status.errors.map(function (err) {
              return err.stack;
            }).join('\n');
            throw error;

          case 42:
            throw liveErrors[liveErrorIndex];

          case 43:
            _context6.next = 62;
            break;

          case 45:
            _context6.next = 47;
            return queryExecutor.sendEvents({
              modelName: promise[_constants.symbol].name,
              events: [{
                type: 'Init'
              }]
            });

          case 47:
            _context6.next = 49;
            return queryExecutor.sendEvents({
              modelName: promise[_constants.symbol].name,
              events: transformEvents(promise[_constants.symbol].events)
            });

          case 49:
            _context6.next = 51;
            return acknowledgePromise;

          case 51:
            _yield$acknowledgePro = _context6.sent;
            projectionError = _yield$acknowledgePro.result.error;

            if (!(projectionError != null)) {
              _context6.next = 62;
              break;
            }

            _liveErrorIndex = liveErrors.findIndex(function (err) {
              return err.message === projectionError.message;
            });

            if (!(_liveErrorIndex < 0)) {
              _context6.next = 61;
              break;
            }

            _error = new Error(projectionError.message);
            _error.stack = projectionError.stack;
            throw _error;

          case 61:
            throw liveErrors[_liveErrorIndex];

          case 62:
            _context6.next = 67;
            break;

          case 64:
            _context6.prev = 64;
            _context6.t2 = _context6["catch"](21);
            errors.push(_context6.t2);

          case 67:
            _context6.prev = 67;
            _context6.next = 70;
            return queryExecutor.read({
              modelName: promise[_constants.symbol].name,
              resolverName: promise[_constants.symbol].resolverName,
              resolverArgs: promise[_constants.symbol].resolverArgs,
              jwt: promise[_constants.symbol].jwt
            });

          case 70:
            _yield$queryExecutor$ = _context6.sent;
            result = _yield$queryExecutor$.data;
            void _yield$queryExecutor$;
            _context6.next = 78;
            break;

          case 75:
            _context6.prev = 75;
            _context6.t3 = _context6["catch"](67);
            errors.push(_context6.t3);

          case 78:
            _context6.prev = 78;

            if (!isInlineLedger) {
              _context6.next = 84;
              break;
            }

            _context6.next = 82;
            return queryExecutor.unsubscribe({
              modelName: promise[_constants.symbol].name
            });

          case 82:
            _context6.next = 86;
            break;

          case 84:
            _context6.next = 86;
            return queryExecutor.drop({
              modelName: promise[_constants.symbol].name
            });

          case 86:
            _context6.next = 91;
            break;

          case 88:
            _context6.prev = 88;
            _context6.t4 = _context6["catch"](78);
            errors.push(_context6.t4);

          case 91:
            _context6.next = 96;
            break;

          case 93:
            _context6.prev = 93;
            _context6.t5 = _context6["catch"](6);
            errors.push(_context6.t5);

          case 96:
            _context6.prev = 96;

            if (!(queryExecutor != null)) {
              _context6.next = 106;
              break;
            }

            _context6.prev = 98;
            _context6.next = 101;
            return queryExecutor.dispose();

          case 101:
            _context6.next = 106;
            break;

          case 103:
            _context6.prev = 103;
            _context6.t6 = _context6["catch"](98);
            errors.push(_context6.t6);

          case 106:
            return _context6.finish(96);

          case 107:
            if (errors.length === 0) {
              promise[_constants.symbol].resolve(result);
            } else {
              summaryError = errors[0];

              if (errors.length > 1) {
                summaryError = new Error(errors.map(function (err) {
                  return err.message;
                }).join('\n'));
                summaryError.stack = errors.map(function (err) {
                  return err.stack;
                }).join('\n');
              } // eslint-disable-next-line no-console


              console.error(summaryError);

              promise[_constants.symbol].reject(errors[0]);
            }

          case 108:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, null, [[6, 93, 96, 107], [21, 64], [67, 75], [78, 88], [98, 103]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.executeReadModel = executeReadModel;
//# sourceMappingURL=execute-read-model.js.map